#include "mbed.h"
#include "PMS3003.h"
#include "BMP180.h"
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include "RESTful.h"
#include "DHT.h"
#include "UC1701.h"
#include "font5x7.h"
#include "font7x10.h"

Serial pc(PC_10, PC_11);
PMS3003 sensor(PA_2, PA_3, PC_5, PA_1, PA_2);
RESTful RSF(PA_9,PA_10,PA_15,9600);

//for test only
//Serial pc(PA_9,PA_10);
//RESTful RSF(PC_10, PC_11,PA_15,9600);
		char SSID_t[50];
		char Password_t[50];
		DigitalIn Wifi_Setup_Button(PB_1);

//init screen, SPI speed is 10Mhz
UC1701 screen(1000000, PB_15, PB_14, PB_13, PA_5, PA_6, PA_7,PC_4);


//I2C i2c(PB_7, PB_6);
//BMP180 bmp180(&i2c);

DHT DHT_sensor(PD_2,DHT11); // Use the DHT11 sensor

DigitalOut led_ticker(PC_12);

unsigned int Time_Ticker = 0;

void Scheduler() {
    if(Time_Ticker%60 == 0){ //every min
	
		//Update Sensor Results to ThingSpeak
		//Wifi and Host information
		char* Host = "54.164.214.198";
		int Port = 80;
		char* API_GET_MSG_PM2DOT5 = "GET /update?api_key=3N2GT3Z5SLAN0KBW&field1=";
		char* API_GET_MSG_PM1 = "GET /update?api_key=3N2GT3Z5SLAN0KBW&field2=";
		char* API_GET_MSG_PM10 = "GET /update?api_key=3N2GT3Z5SLAN0KBW&field3=";
//		char* API_GET_MSG_Atmospheric_Pressure = "GET /update?api_key=3N2GT3Z5SLAN0KBW&field4=";
		char* API_GET_MSG_Temperature = "GET /update?api_key=3N2GT3Z5SLAN0KBW&field5=";
		char* API_GET_MSG_Humidity = "GET /update?api_key=3N2GT3Z5SLAN0KBW&field6=";
		char* API_GET_MSG_DewPoint = "GET /update?api_key=3N2GT3Z5SLAN0KBW&field7=";
		int Retry_Times = 3;
	
		//Varilables
		int error;
		char HTTPRequest_Buffer[500]="";
		char Argument_Buffer[50]="";
		char HTTPResponce[500]="";
		int HTTPResponce_Size = 500;
	
		error = RSF.connectToAP(SSID_t, Password_t,Retry_Times);

		error = RSF.connectToAP(SSID_t, Password_t,Retry_Times);
		if(error == 0){
			// error code = 0 means ERROR_NONE, Connected to AP
			pc.printf("===================================\r\nConnectToAP Error code is: %d\r\n", error);
			pc.printf("IP address is: %s\r\n-----------------------------------\r\n", RSF.getIPAddress());


		
			//PM Sensor
			int PM2dot5 = 0;
			int PM1     = 0;
			int PM10    = 0;
			
		
			sensor.init();
			//Power on the PM Sensor
			sensor.PowerOn();
			wait(10); //wait for sensor setup

			PM2dot5 = (int)sensor.getPM2dot5();
			PM1 = (int)sensor.getPM1();
			PM10 = (int)sensor.getPM10();
			
			//Power off PM Sensor
			sensor.PowerOff();
			
			
			//Post PM2.5
			pc.printf("Sending PM2.5\r\n");
			sprintf(Argument_Buffer,"%d",PM2dot5);
			char* getRequest_PM2DOT5 = RSF.generateGETRequest(HTTPRequest_Buffer, API_GET_MSG_PM2DOT5, Argument_Buffer);
			error = RSF.sendHTTPRequest(getRequest_PM2DOT5, HTTPResponce, HTTPResponce_Size, Host, Port,Retry_Times);
			pc.printf("the GET Request is: %s\r\n",getRequest_PM2DOT5);
			pc.printf("HTTPResponce is: %s\r\n", HTTPResponce);
			pc.printf("SendHTTPRequest Error code is %d\r\n-----------------------------------\r\n", error);
			
			wait(15);
			//Post PM1
			pc.printf("Sending PM1\r\n");
			sprintf(Argument_Buffer,"%d",PM1);
			char* getRequest_PM1 = RSF.generateGETRequest(HTTPRequest_Buffer, API_GET_MSG_PM1, Argument_Buffer);
			error = RSF.sendHTTPRequest(getRequest_PM1, HTTPResponce, HTTPResponce_Size, Host, Port,Retry_Times);
			pc.printf("the GET Request is: %s\r\n",getRequest_PM1);
			pc.printf("HTTPResponce is: %s\r\n", HTTPResponce);
			pc.printf("SendHTTPRequest Error code is %d\r\n-----------------------------------\r\n", error);
			
			wait(15);
			//Post PM10
			pc.printf("Sending PM10\r\n");
			sprintf(Argument_Buffer,"%d",PM10);
			char* getRequest_PM10 = RSF.generateGETRequest(HTTPRequest_Buffer, API_GET_MSG_PM10, Argument_Buffer);
			error = RSF.sendHTTPRequest(getRequest_PM10, HTTPResponce, HTTPResponce_Size, Host, Port,Retry_Times);
			pc.printf("the GET Request is: %s\r\n",getRequest_PM10);
			pc.printf("HTTPResponce is: %s\r\n", HTTPResponce);
			pc.printf("SendHTTPRequest Error code is %d\r\n-----------------------------------\r\n", error);
			
			

/*
			wait(15);
			//Post Atmospheric Pressure
			//Get Data
			  bmp180.startPressure(BMP180::ULTRA_HIGH_RESOLUTION);
        wait_ms(80);    // Wait for conversion to complete
        int pressure;
        if(bmp180.getPressure(&pressure) != 0) {
            pc.printf("Error getting pressure\r\n");
            //continue;
        }
			//Post Data	
			pc.printf("Sending Atmospheric Pressure\r\n");
			sprintf(Argument_Buffer,"%d",pressure);
			char* getRequest_Atmospheric_Pressure = RSF.generateGETRequest(HTTPRequest_Buffer, API_GET_MSG_Atmospheric_Pressure, Argument_Buffer);
			error = RSF.sendHTTPRequest(getRequest_Atmospheric_Pressure, HTTPResponce, HTTPResponce_Size, Host, Port,Retry_Times);
			pc.printf("the GET Request is: %s\r\n",getRequest_Atmospheric_Pressure);
			pc.printf("HTTPResponce is: %s\r\n", HTTPResponce);
			pc.printf("SendHTTPRequest Error code is %d\r\n-----------------------------------\r\n", error);
				*/
				
				
			//DHT Sensor
			int DHT_err;
			float Temperature=0;
			float Humidity=0;
			float DewPoint=0;
			int DHT_err_counter = 0;
			
			while(1){
				DHT_err = DHT_sensor.readData();
				if (DHT_err == ERROR_NONE) {
					Temperature = DHT_sensor.ReadTemperature(CELCIUS);
					Humidity = DHT_sensor.ReadHumidity();
					DewPoint = DHT_sensor.CalcdewPoint(Temperature, Humidity);
					
					//Post Temperature
					wait(15);
					pc.printf("Sending Temperature\r\n");
					sprintf(Argument_Buffer,"%f",Temperature);
					char* getRequest_Temperature = RSF.generateGETRequest(HTTPRequest_Buffer, API_GET_MSG_Temperature, Argument_Buffer);
					error = RSF.sendHTTPRequest(getRequest_Temperature, HTTPResponce, HTTPResponce_Size, Host, Port,Retry_Times);
					pc.printf("the GET Request is: %s\r\n",getRequest_Temperature);
					pc.printf("HTTPResponce is: %s\r\n", HTTPResponce);
					pc.printf("SendHTTPRequest Error code is %d\r\n-----------------------------------\r\n", error);
			
					//Post Humidity
					wait(15);
					pc.printf("Sending Humidity\r\n");
					sprintf(Argument_Buffer,"%f",Humidity);
					char* getRequest_Humidity = RSF.generateGETRequest(HTTPRequest_Buffer, API_GET_MSG_Humidity, Argument_Buffer);
					error = RSF.sendHTTPRequest(getRequest_Humidity, HTTPResponce, HTTPResponce_Size, Host, Port,Retry_Times);
					pc.printf("the GET Request is: %s\r\n",getRequest_Humidity);
					pc.printf("HTTPResponce is: %s\r\n", HTTPResponce);
					pc.printf("SendHTTPRequest Error code is %d\r\n-----------------------------------\r\n", error);
			
					//Post DewPoint
					wait(15);
					pc.printf("Sending DewPoint\r\n");
					sprintf(Argument_Buffer,"%f",DewPoint);
					char* getRequest_DewPoint = RSF.generateGETRequest(HTTPRequest_Buffer, API_GET_MSG_DewPoint, Argument_Buffer);
					error = RSF.sendHTTPRequest(getRequest_DewPoint, HTTPResponce, HTTPResponce_Size, Host, Port,Retry_Times);
					pc.printf("the GET Request is: %s\r\n",getRequest_DewPoint);
					pc.printf("HTTPResponce is: %s\r\n", HTTPResponce);
					pc.printf("SendHTTPRequest Error code is %d\r\n-----------------------------------\r\n", error);
					
					break;
				}else{
					//Error
					DHT_err_counter++;
					wait_ms(10);
					if(DHT_err_counter > 150){
						pc.printf("DHT 22 sensor Error is %i \r\n===================================\r\n",DHT_err);
						break;
					}
				}
			}

			//Update Screen
			char screen_buffer [17]; //buffer for one line of chars
			//Clean screen
			screen.UC1701_Fill(0x00); //clear screen
			//Update data
			sprintf (screen_buffer, "PM1  :%4d ug/m3", PM1);
			screen.PutStr(0, 2, screen_buffer, &Font5x7_Def, Font5x7);
			sprintf (screen_buffer, "PM2.5:%4d ug/m3", PM2dot5);
			screen.PutStr(0, 10, screen_buffer, &Font5x7_Def, Font5x7);
			sprintf (screen_buffer, "PM10 :%4d ug/m3", PM10);
			screen.PutStr(0, 18, screen_buffer, &Font5x7_Def, Font5x7);
			
			screen.HLine(0,95, 26, PSet);
			screen.HLine(0,95 , 27, PSet);
				
			sprintf (screen_buffer, "T:%2.0f C  RH:%2.0f %%",Temperature, Humidity);
			screen.PutStr(0, 29, screen_buffer, &Font5x7_Def, Font5x7);
			sprintf (screen_buffer, "Dew Point:%4.2f", DewPoint);
			screen.PutStr(0, 37, screen_buffer, &Font5x7_Def, Font5x7);

			screen.UC1701_Flush();
			
			
		}else{
			//Connect to AP failed
			pc.printf("Connect to AP failed! Please check your SSDI and Password!\r\n");
		}
	}
}

void Wifi_Setup() {
	//Display Information on the Screen
	//Init Screen
	screen.UC1701_Init();
	screen.UC1701_Contrast(5,32);
	screen.UC1701_Orientation(scr_normal);
	screen.UC1701_Fill(0x00); //clear screen
	
	//Update Screen
	screen.PutStr(0, 2, " WIFI Setup", &Font7x10_Def, Font7x10);
	screen.PutStr(0, 18, "SSID: SENSOR_AP", &Font5x7_Def, Font5x7);
	screen.PutStr(0, 26, "PWD: password", &Font5x7_Def, Font5x7);
	screen.PutStr(0, 34, "IP: 192.168.4.1", &Font5x7_Def, Font5x7);
	
	screen.UC1701_Flush();
	
	//Entering WIFI Setup 
  pc.printf("WIFI Setup!\r\n");  
	RSF.WifiSetup();
	pc.printf("Waiting for WIFI Setup!\r\n");
	
	//Break additional operation to ESP8266
	while(true){
	led_ticker = !led_ticker;
	wait_ms(300);
	}
}

int main()
{
	//Enter WIFI Setup or Not
	if(!Wifi_Setup_Button){
	//The button is pressed during power up
	Wifi_Setup();
	}
	/*
	//Init BMP180
			while(1) {
        if (bmp180.init() != 0) {
            pc.printf("Error communicating with BMP180\r\n");
        } else {
            pc.printf("Initialized BMP180\r\n");
            break;
        }
        wait(1);
    }
		*/
		//Init Screen
		screen.UC1701_Init();
		screen.UC1701_Contrast(5,32);
		screen.UC1701_Orientation(scr_normal);
		screen.UC1701_Fill(0x00); //clear screen
		
		
		//Get SSID and Password from Flash IC on the WIFI module
		memset(SSID_t,0,sizeof(SSID_t));
		memset(Password_t,0,sizeof(Password_t));
		
		RSF.GetWifiCfg(SSID_t,Password_t, 50);
		pc.printf("Saved SSID is %s, and Password is %s\r\n", SSID_t, Password_t);
		
		//Display WIFI Information on the screen
			char screen_buffer [17]; //buffer for one line of chars
			//Clean screen
			screen.UC1701_Fill(0x00); //clear screen
			//Update data
			screen.PutStr(0, 2, " WIFI Info", &Font7x10_Def, Font7x10);
			//sprintf (screen_buffer, "PM1  :%4d ug/m3", PM1);
			screen.PutStr(0, 13, "SSID:", &Font5x7_Def, Font5x7);
			sprintf (screen_buffer, "%s", SSID_t);
			screen.PutStr(0, 21, screen_buffer, &Font5x7_Def, Font5x7);
			//sprintf (screen_buffer, "PM10 :%4d ug/m3", PM10);
			screen.PutStr(0, 29, "PWD:", &Font5x7_Def, Font5x7);
			sprintf (screen_buffer, "%s", Password_t);
			screen.PutStr(0, 37, screen_buffer, &Font5x7_Def, Font5x7);

			screen.UC1701_Flush();


	led_ticker = 0;
	while(1){
		if(Time_Ticker != 65530){
			wait(1);
			led_ticker = !led_ticker;
			Scheduler();
			Time_Ticker++;
			}else{
				Time_Ticker = 0;
			}
	}
}

